#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static long int *pals;     /* lista de palindromos
			      encontrados. Primeiro elemento ==
			      quantidade de numeros no vetor. */

static char digiNums[50];  /* digitos de um numero.*/


static int ehPalindromo (long int n)
{

  int i, j, k, ndigi, ehPal = 0;

  sprintf (digiNums, "%ld", n);

  ndigi = strlen (digiNums);

  if (ndigi % 2)
    --ndigi;

  for (k = 0, i = 0, j = strlen (digiNums); k < (ndigi/2) && ehPal; k++, i++, j--)
    ehPal = (digiNums[i] == digiNums[j]);

  return ehPal;
}

long int *palins (long int n1, long int n2 )
{

  long int tmp;
  int i;

  pals = calloc (1, sizeof(long int));

  if (pals) {
    if (n1 > n2) {
      tmp = n1;
      n1 = n2;
      n2 = tmp;
    }
    
    for (i = n1; i <= n2; i++)
      if (ehPalindromo (i)) {
	pals = realloc (pals, (pals[0] + 1) * sizeof(long int));
	if (!pals) {
	  break;
	}
	else {
	  pals[++pals[0]] = i;
	}
      }
  }

  return pals;
}

